Package org.optaplanner.core.impl.score.director.incremental

## Class IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory<Solution_,​Score_>
  - - org.optaplanner.core.impl.score.director.incremental.IncrementalScoreDirectorFactory<Solution_,​Score_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
    `Score_` - the score type to go with the solution
  All Implemented Interfaces:
    `InnerScoreDirectorFactory<Solution_,​Score_>`, `ScoreDirectorFactory<Solution_>`

      public class IncrementalScoreDirectorFactory<Solution_,​Score_ extends Score<Score_>>
      extends AbstractScoreDirectorFactory<Solution_,​Score_>

  Incremental implementation of `ScoreDirectorFactory`.
  See Also:
    `IncrementalScoreDirector`, `ScoreDirectorFactory`

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertClonedSolution, assertionScoreDirectorFactory, initializingScoreTrend, logger, solutionDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `IncrementalScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor, Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass, Map<String,​String> incrementalScoreCalculatorCustomProperties)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `IncrementalScoreDirector<Solution_,​Score_>` | `buildScoreDirector​(boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` | Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirectorFactory

      `assertScoreFromScratch, buildScoreDirector, getAssertionScoreDirectorFactory, getInitializingScoreTrend, getScoreDefinition, getSolutionDescriptor, isAssertClonedSolution, setAssertClonedSolution, setAssertionScoreDirectorFactory, setInitializingScoreTrend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IncrementalScoreDirectorFactory

          public IncrementalScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor,
                                                 Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass,
                                                 Map<String,​String> incrementalScoreCalculatorCustomProperties)

  - ### Method Detail

    - #### buildScoreDirector

          public IncrementalScoreDirector<Solution_,​Score_> buildScoreDirector​(boolean lookUpEnabled,
                                                                                     boolean constraintMatchEnabledPreference)

      Description copied from interface: `InnerScoreDirectorFactory`
      Like `InnerScoreDirectorFactory.buildScoreDirector()`, but optionally disables `ConstraintMatch` tracking and look up for more performance (presuming the `ScoreDirector` implementation actually supports it to begin with).
      Parameters:
        `lookUpEnabled` - true if a `ScoreDirector` implementation should track all working objects for `ScoreDirector.lookUpWorkingObject(Object)`
        `constraintMatchEnabledPreference` - false if a `ScoreDirector` implementation should not do `ConstraintMatch` tracking even if it supports it.
      Returns:
        never null
      See Also:
        `InnerScoreDirector.isConstraintMatchEnabled()`, `InnerScoreDirector.getConstraintMatchTotalMap()`